package com.ihaoin.hooloo.device;

import android.app.Application;
import android.util.Log;

import com.ihaoin.hooloo.device.config.AppConfig;
import com.ihaoin.hooloo.device.data.MainData;
import com.ihaoin.hooloo.device.data.TrolleyGoods;
import com.ihaoin.hooloo.device.network.HttpUtil;
import com.ihaoin.hooloo.device.util.SharedPreferencesUtils;
import com.ihaoin.hooloo.device.util.StringUtils;
import com.umeng.commonsdk.UMConfigure;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

import cn.jpush.android.api.JPushInterface;

public class HLApplication extends Application {
    public static HLApplication SELF = null;
    private static MainData mainData = new MainData();
    private static List<TrolleyGoods> TROLLEY_GOODS = new ArrayList<>();
    public static MainData getMainData() {
        return mainData;
    }

    public static void setMainData(MainData data) {
        mainData = data;
    }

    public static List<TrolleyGoods> getTrolleyGoods() {
        return TROLLEY_GOODS;
    }

    @Override
    public void onCreate() {
        super.onCreate();
        HLApplication.SELF = this;
        UMConfigure.preInit(this, AppConfig.UMENG_APPKEY, AppConfig.UMENG_CHANNEL);
        UMConfigure.init(this, AppConfig.UMENG_APPKEY, AppConfig.UMENG_CHANNEL, 0, null);

        AppConfig.MACHINE_CODE = SharedPreferencesUtils.getMachineCode(this);

        JPushInterface.setDebugMode(true);
        JPushInterface.init(this);

        String registrationId = JPushInterface.getRegistrationID(this);
        Log.d(AppConfig.TAG_PUSH, "get registrationId:" + registrationId);
        if (!StringUtils.isEmpty(registrationId)) {
            HttpUtil.postRegistrationId(registrationId, null);
        }
    }

    @Override
    public void onTerminate() {
        super.onTerminate();
    }

    public static  Integer getCountOfOrder() {
        if (HLApplication.getMainData() == null || HLApplication.getMainData().getCountOfOrder() == null) {
            return 9;
        }
        return HLApplication.getMainData().getCountOfOrder();
    }

    public static Integer getGoodsCount() {
        return HLApplication.getTrolleyGoods().stream().mapToInt(TrolleyGoods::getCount).sum();
    }

    public static Integer getGoodsCheckedCount() {
        return HLApplication.getTrolleyGoods().stream().filter(TrolleyGoods::getChecked).mapToInt(TrolleyGoods::getCount).sum();
    }

    public static BigDecimal getGoodsTotal() {
        return HLApplication.getTrolleyGoods().stream().map(x -> x.getSku().getDiscount().multiply(new BigDecimal(x.getCount()))).reduce(BigDecimal.ZERO, BigDecimal::add);
    }

    public static BigDecimal getGoodsCheckedTotal() {
        return HLApplication.getTrolleyGoods().stream().filter(TrolleyGoods::getChecked).map(x -> x.getSku().getDiscount().multiply(new BigDecimal(x.getCount()))).reduce(BigDecimal.ZERO, BigDecimal::add);
    }
}
